import { IModelType } from "mobx-state-tree";
import { IAnything, IFieldErrors } from "../Common";
import { IType, ITypeConfig, ITypeMetaProps } from "../Type";
import { IValue, IValueAttrs, IValueConfig } from "../Value";
import { IMeta, IMetaAttrs, IMetaConfig } from "../Meta";
export declare type IArrayComponent = "list" | "layout" | "checkboxes";
export interface IArrayMetaAttrs extends IMetaAttrs<Array<IAnything | null>, IArrayComponent> {
}
export interface IArrayMetaConfig extends IMetaConfig<Array<IAnything | null>, IArrayComponent>, IArrayMetaAttrs {
}
export interface IArrayMeta extends IMeta<Array<IAnything | null>, IArrayComponent>, IArrayMetaAttrs {
}
export declare type IArrayType = "array";
export interface IArrayMetaProps extends IArrayMetaConfig {
    readonly type: IArrayType;
    readonly items?: ITypeMetaProps | ITypeMetaProps[] | null;
}
export interface IArrayAttrs extends IValueAttrs<Array<IAnything | null>> {
    readonly additionalItems?: boolean | null;
    readonly minItems?: number | null;
    readonly maxItems?: number | null;
    readonly uniqueItems?: boolean | null;
    readonly items?: ITypeConfig | ITypeConfig[] | null;
}
export interface IArrayConfig extends IValueConfig<Array<IAnything | null>, IArrayType, IArrayComponent, IArrayMetaConfig>, Partial<IArrayAttrs> {
}
export interface IArray extends IArrayAttrs, IValue<Array<IAnything | null>, IArrayType, IArrayComponent, IArrayMetaConfig, IArrayMeta> {
    readonly elements: IType[];
    readonly dynamic: boolean;
    push(): void;
    remove(index: number): void;
    getFieldErrors(): IFieldErrors;
    updateIndexValue(index: number, value: IAnything | null): void;
}
export declare const ArrayMeta: IModelType<Partial<IArrayMetaConfig>, IArrayMeta>;
export declare function createArray(): IModelType<Partial<IArrayConfig>, IArray>;
