import { types } from "mobx-state-tree";
import { mappings } from "../Common";
import { createValue } from "../Value";
import { createMeta } from "../Meta";
export var BooleanMeta = types.compose("BooleanMeta", createMeta(types.boolean, false, "radios", "checkbox", "switch", "select"), types.model({}));
// tslint:disable-next-line:variable-name
export var Boolean = types
    .compose("Boolean", createValue("boolean", types.boolean, false, BooleanMeta, { component: "switch" }), types.model({}))
    .actions(function (it) { return ({
    afterCreate: function () {
        if (it.enum) {
            if (!(it.enum.length === 2)) {
                throw new TypeError("boolean enum should be two values. '" + it.enum + "' is invalid.");
            }
            if (it.enum[0] !== true && it.enum[0] !== false) {
                throw new TypeError("boolean enum should have either 'true' or 'false'");
            }
            if (it.enum[1] !== true && it.enum[1] !== false) {
                throw new TypeError("boolean enum should have either 'true' or 'false'");
            }
        }
        var component = it.meta.component;
        if ((component === "select" || component === "radios") &&
            (!it.enum || it.enum.length === 0)) {
            it.enum = [true, false];
        }
        if (it.enum &&
            it.enum.length > 0 &&
            (!it.meta.options || it.meta.options.length === 0)) {
            var options = it.enum.map(function (option) { return ({
                label: String(option),
                value: option
            }); });
            it.meta.setOptions(options);
        }
    }
}); });
mappings.boolean = Boolean;
export function createBoolean() {
    return Boolean;
}
//# sourceMappingURL=Boolean.js.map