import { types } from "mobx-state-tree";
export function createMeta(kind, defaultv) {
    var components = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        components[_i - 2] = arguments[_i];
    }
    var Meta = types
        .model("Meta", {
        component: types.maybe(types.enumeration("component", components)),
        default: types.optional(kind, defaultv),
        disabled: types.optional(types.boolean, false),
        error: types.maybe(types.string),
        help: types.maybe(types.string),
        icon: types.maybe(types.string),
        iconAlign: types.optional(types.enumeration("iconAlign", ["start", "end"]), "start"),
        initial: types.optional(kind, defaultv),
        mandatory: types.optional(types.boolean, false),
        name: types.optional(types.string, ""),
        options: types.maybe(types.array(types.model({ label: types.string, value: kind }))),
        row: types.maybe(types.boolean),
        sequence: types.maybe(types.number),
        value: types.optional(kind, defaultv),
        visible: types.optional(types.boolean, true)
    })
        .actions(function (it) { return ({
        afterCreate: function () {
            it.initial = it.value;
        }
    }); })
        .actions(function (it) { return ({
        setName: function (name) {
            it.name = name;
        },
        setMandatory: function (mandatory) {
            it.mandatory = mandatory;
        },
        setDisabled: function (disabled) {
            it.disabled = disabled;
        },
        setVisible: function (visible) {
            it.visible = visible;
        },
        setInitial: function (initial) {
            it.initial = initial;
        },
        setValue: function (value) {
            it.value = value;
        },
        setDefault: function (defaultV) {
            it.default = defaultV;
        },
        setOptions: function (options) {
            it.options = options;
        }
    }); });
    return Meta;
}
//# sourceMappingURL=Meta.js.map