import { IModelType } from "mobx-state-tree";
import { IValue, IValueAttrs, IValueConfig } from "../Value";
import { IMeta, IMetaAttrs, IMetaConfig } from "../Meta";
export declare type INullComponent = "para";
export interface INullMetaAttrs extends IMetaAttrs<null, INullComponent> {
}
export interface INullMetaConfig extends IMetaConfig<null, INullComponent>, INullMetaAttrs {
}
export interface INullMeta extends IMeta<null, INullComponent>, INullMetaAttrs {
}
export declare type INullType = "null";
export interface INullMetaProps extends INullMetaConfig {
    readonly type: INullType;
}
export interface INullAttrs extends IValueAttrs<null> {
}
export interface INullConfig extends IValueConfig<null, INullType, INullComponent, INullMetaConfig>, Partial<INullAttrs> {
}
export interface INull extends INullAttrs, IValue<null, INullType, INullComponent, INullMetaConfig, INullMeta> {
}
export declare const NullMeta: IModelType<Partial<INullMetaConfig>, INullMeta>;
export declare const Null: IModelType<Partial<INullConfig>, INull>;
export declare function createNull(): IModelType<Partial<INullConfig>, INull>;
