import { IModelType } from "mobx-state-tree";
import { IValue, IValueAttrs, IValueConfig } from "../Value";
import { IMeta, IMetaAttrs, IMetaConfig } from "../Meta";
export declare type INumberComponent = "number" | "range" | "radios" | "text" | "select";
export interface INumberMetaAttrs extends IMetaAttrs<number, INumberComponent> {
    readonly step?: number | null;
}
export interface INumberMetaConfig extends IMetaConfig<number, INumberComponent>, INumberMetaAttrs {
}
export interface INumberMeta extends IMeta<number, INumberComponent>, INumberMetaAttrs {
}
export declare type INumberType = "number";
export interface INumberMetaProps extends INumberMetaConfig {
    readonly type: INumberType;
}
export interface INumberAttrs extends IValueAttrs<number> {
    readonly minimum?: number | null;
    readonly maximum?: number | null;
    readonly multipleOf?: number | null;
}
export interface INumberConfig extends IValueConfig<number, INumberType, INumberComponent, INumberMetaConfig>, Partial<INumberAttrs> {
}
export interface INumber extends INumberAttrs, IValue<number, INumberType, INumberComponent, INumberMetaConfig, INumberMeta> {
}
export declare const NumberMeta: IModelType<Partial<INumberMetaConfig>, INumberMeta>;
export declare const Number: IModelType<Partial<INumberConfig>, INumber>;
export declare function createNumber(): IModelType<Partial<INumberConfig>, INumber>;
