var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import { types } from "mobx-state-tree";
import { toJS } from "mobx";
import { keys, unique } from "../utils";
import { mappings } from "../Common";
import { createValue } from "../Value";
import { createType } from "../Type";
import { createMeta } from "../Meta";
mappings.object = types.late("Object", createObject);
var NObject;
export var ObjectMeta = types.compose("ObjectMeta", createMeta(types.map(types.frozen), {}, "grid", "layout", "list"), types.model({
    layout: types.optional(types.frozen, null)
}));
export function createObject() {
    if (!NObject) {
        var XObject = types
            .compose("Object", createValue("object", types.map(types.frozen), {}, ObjectMeta, {
            component: "layout"
        }), types.model({
            additionalProperties: types.maybe(types.union(types.boolean, types.late(createType))),
            maxProperties: types.maybe(types.number),
            minProperties: types.maybe(types.number),
            properties: types.maybe(types.map(types.late(createType))),
            required: types.maybe(types.array(types.string))
        }))
            .volatile(function (it) { return ({
            getActuals: function (value) {
                if (value === null) {
                    return [];
                }
                var props = [];
                value.forEach(function (v, key) { return props.push(key); });
                return props;
            }
        }); })
            .volatile(function (it) { return ({
            getAdditionals: function (value) {
                return it
                    .getActuals(value)
                    .filter(function (prop) { return !it.properties || !it.properties.has(prop); });
            },
            getProperties: function () {
                if (it.properties) {
                    return Array.from(it.properties.keys()).slice(0);
                }
                return [];
            },
            getProperty: function (property) {
                return it.properties
                    ? it.properties.get(property)
                    : undefined;
            }
        }); })
            .actions(function (it) { return ({
            updateProps: function (value) {
                if (value) {
                    keys(value).forEach(function (key) {
                        var type = it.getProperty(key);
                        if (type) {
                            return type.setValue(value[key]);
                        }
                    });
                }
            }
        }); })
            .views(function (it) { return ({
            get count() {
                return it.properties ? it.properties.size : 0;
            },
            get valid() {
                return (it.errors.length === 0 &&
                    it
                        .getProperties()
                        .every(function (property) { return it.getProperty(property).valid; }));
            },
            get fields() {
                return it.properties
                    ? Array.from(it.properties.values())
                    : [];
            }
        }); })
            .actions(function (it) { return ({
            afterCreate: function () {
                var e_1, _a, e_2, _b;
                if (it.minProperties !== null && it.minProperties < 0) {
                    throw new TypeError("minProperties can not be negative");
                }
                if (it.maxProperties !== null && it.maxProperties < 0) {
                    throw new TypeError("maxProperties can not be negative");
                }
                if (it.required !== null &&
                    it.required.length !== unique(it.required).length) {
                    throw new TypeError("required should not have duplicate properties");
                }
                if (it.properties) {
                    try {
                        for (var _c = __values(it.properties.entries()), _d = _c.next(); !_d.done; _d = _c.next()) {
                            var _e = __read(_d.value, 2), key = _e[0], field = _e[1];
                            field.meta.setName(key);
                            if (!field.title) {
                                field.setTitle(key);
                            }
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (_d && !_d.done && (_a = _c.return)) _a.call(_c);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                }
                if (it.required !== null) {
                    try {
                        for (var _f = __values(it.required), _g = _f.next(); !_g.done; _g = _f.next()) {
                            var required = _g.value;
                            var property = it.getProperty(required);
                            if (property) {
                                property.meta.setMandatory(true);
                            }
                        }
                    }
                    catch (e_2_1) { e_2 = { error: e_2_1 }; }
                    finally {
                        try {
                            if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
                        }
                        finally { if (e_2) throw e_2.error; }
                    }
                }
                it.updateProps(toJS(it.meta.value));
            }
        }); })
            .actions(function (it) { return ({
            doValidate: function (value) {
                var e_3, _a, e_4, _b, e_5, _c;
                var errors = it.doValidateBase(value);
                if (value === null) {
                    return errors;
                }
                if (it.minProperties !== null && value.size < it.minProperties) {
                    errors.push("should NOT have less than " + it.minProperties + " properties");
                }
                if (it.maxProperties !== null && value.size > it.maxProperties) {
                    errors.push("should NOT have more than " + it.maxProperties + " properties");
                }
                // required is handled in respective fields
                // if (it.required !== null) {
                //     const actuals = it.getActuals(value);
                //     const requireds = it.required.filter(
                //         required => !actuals.includes(required)
                //     );
                //     if (requireds.length > 0) {
                //         errors.push(
                //             `should have required properties [${requireds.join(
                //                 ', '
                //             )}]`
                //         );
                //     }
                // }
                if (it.additionalProperties !== null &&
                    typeof toJS(it.additionalProperties) === "boolean") {
                    var additionals = it.getAdditionals(value);
                    if (additionals.length > 0) {
                        if (!it.additionalProperties) {
                            errors.push("should NOT have additional properties [" + additionals.join(", ") + "]");
                        }
                    }
                }
                if (value !== null &&
                    it.additionalProperties !== null &&
                    typeof toJS(it.additionalProperties) !== "boolean") {
                    var additionals = it.getAdditionals(value);
                    if (additionals.length > 0) {
                        var extratype = it.additionalProperties;
                        try {
                            for (var additionals_1 = __values(additionals), additionals_1_1 = additionals_1.next(); !additionals_1_1.done; additionals_1_1 = additionals_1.next()) {
                                var additional = additionals_1_1.value;
                                try {
                                    for (var _d = __values(extratype.tryValidate(value.get(additional))), _e = _d.next(); !_e.done; _e = _d.next()) {
                                        var error = _e.value;
                                        errors.push("additional property '" + additional + "' " + error.replace("Value ", ""));
                                    }
                                }
                                catch (e_4_1) { e_4 = { error: e_4_1 }; }
                                finally {
                                    try {
                                        if (_e && !_e.done && (_b = _d.return)) _b.call(_d);
                                    }
                                    finally { if (e_4) throw e_4.error; }
                                }
                            }
                        }
                        catch (e_3_1) { e_3 = { error: e_3_1 }; }
                        finally {
                            try {
                                if (additionals_1_1 && !additionals_1_1.done && (_a = additionals_1.return)) _a.call(additionals_1);
                            }
                            finally { if (e_3) throw e_3.error; }
                        }
                    }
                }
                try {
                    for (var _f = __values(it.getProperties()), _g = _f.next(); !_g.done; _g = _f.next()) {
                        var property = _g.value;
                        it.getProperty(property).validate();
                    }
                }
                catch (e_5_1) { e_5 = { error: e_5_1 }; }
                finally {
                    try {
                        if (_g && !_g.done && (_c = _f.return)) _c.call(_f);
                    }
                    finally { if (e_5) throw e_5.error; }
                }
                return errors;
            },
            setValue: function (value) {
                it.meta.setValue(value);
                it.updateProps(toJS(value));
            },
            reset: function () {
                it.errors.length = 0;
                it.fields.forEach(function (field) { return field.reset(); });
            }
        }); })
            .views(function (it) { return ({
            getFieldErrors: function () {
                var properties = it.getProperties();
                return properties.reduce(function (errors, key) {
                    var type = it.getProperty(key);
                    errors.properties[key] = type.getFieldErrors
                        ? type.getFieldErrors()
                        : toJS(type.errors);
                    return errors;
                }, { errors: toJS(it.errors), properties: {} });
            },
            get data() {
                var properties = it.getProperties();
                return properties.reduce(function (data, key) {
                    var type = it.getProperty(key);
                    data[key] = type.data;
                    return data;
                }, __assign({}, toJS(it.meta.value || {})));
            },
            get modified() {
                return it.fields.some(function (field) { return field.modified; });
            },
            get validating() {
                return (it._validating || it.fields.some(function (field) { return field.validating; }));
            }
        }); });
        NObject = XObject;
    }
    return NObject;
}
//# sourceMappingURL=Object.js.map