var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
import { types } from "mobx-state-tree";
import { regex } from "../utils";
import { mappings } from "../Common";
import { matchers } from "./matchers";
import { createValue } from "../Value";
import { createMeta } from "../Meta";
export var StringMeta = types.compose("StringMeta", createMeta(types.string, "", "text", "select", "color", "date", "password", "datetime", "textarea", "time"), types.model({
    rows: types.maybe(types.number),
    rowsMax: types.maybe(types.number)
}));
// tslint:disable-next-line:variable-name
export var String = types
    .compose("String", createValue("string", types.string, "", StringMeta, {
    component: "text"
}), types.model({
    format: types.maybe(types.union.apply(types, __spread(Object.keys(matchers).map(function (format) { return types.literal(format); })))),
    maxLength: types.maybe(types.number),
    minLength: types.maybe(types.number),
    pattern: types.maybe(types.string)
}))
    .actions(function (it) { return ({
    afterCreate: function () {
        if (it.pattern != null && !regex(it.pattern)) {
            throw new TypeError("pattern '" + it.pattern + "' is invalid.");
        }
    }
}); })
    .actions(function (it) { return ({
    doValidate: function (value) {
        var errors = it.doValidateBase(value);
        if (it.minLength !== null && value.length < it.minLength) {
            errors.push("should NOT be shorter than " + it.minLength + " characters");
        }
        if (it.maxLength !== null && value.length > it.maxLength) {
            errors.push("should NOT be longer than " + it.maxLength + " characters");
        }
        if (it.pattern !== null && !value.match(regex(it.pattern))) {
            errors.push("should match pattern " + it.pattern);
        }
        if (it.format != null && !matchers[it.format](value)) {
            errors.push("should match format " + it.format);
        }
        return errors;
    }
}); });
mappings.string = String;
export function createString() {
    return String;
}
//# sourceMappingURL=String.js.map