var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
import { toJS } from "mobx";
import { types } from "mobx-state-tree";
export function createValue(type, kind, defaultv, meta, defaultMeta) {
    var Value = types
        .compose(types.model("Meta", {
        meta: types.optional(meta, defaultMeta)
    }), types.model("Value", {
        const: types.maybe(kind),
        enum: types.maybe(types.array(kind)),
        errors: types.optional(types.array(types.string), []),
        title: types.maybe(types.string),
        type: types.literal(type)
    }))
        .volatile(function (it) { return ({ _validating: false, syncing: false }); })
        .actions(function (it) { return ({
        afterCreate: function () {
            if (it.errors.length > 0) {
                throw new Error("errors property can not be configured for field " + it.title);
            }
            if (it.meta.name === "" && it.title) {
                var title = it.title;
                it.meta.setName(title.toLowerCase().replace(" ", "-"));
            }
            if (it.enum &&
                it.enum.length > 0 &&
                (!it.meta.options || it.meta.options.length === 0)) {
                var options = it.enum.map(function (option) { return ({
                    label: String(option),
                    value: option
                }); });
                it.meta.setOptions(options);
            }
        },
        setTitle: function (title) {
            it.title = title;
        },
        tryValue: function (value) {
            return kind.is(value);
        }
    }); })
        .actions(function (it) { return ({
        doValidateBase: function (value) {
            var errors = [];
            if (it.meta.mandatory !== null &&
                it.meta.mandatory &&
                (value === null || value === defaultv)) {
                errors.push("Field is required");
            }
            if (it.const !== null && value !== it.const) {
                errors.push("should be equal to " + it.const);
            }
            if (it.enum &&
                it.enum.length > 0 &&
                it.enum.findIndex(function (en) { return en === value; }) === -1) {
                errors.push("should be equal to one of the allowed values [" + it.enum.join(", ") + "]");
            }
            return errors;
        }
    }); })
        .volatile(function (it) { return ({
        doValidate: function (value) {
            return it.doValidateBase(value);
        }
    }); })
        .volatile(function (it) { return ({
        tryValidate: function (value) {
            var validities = kind.validate(value, []);
            var errors = validities
                .map(function (validity) { return validity.message; })
                .filter(function (message) { return !!message; });
            if (errors.length === 0) {
                errors.push.apply(errors, __spread(it.doValidate(value)));
            }
            return errors;
        }
    }); })
        .views(function (it) { return ({
        get modified() {
            return it.meta.value !== it.meta.initial;
        },
        get valid() {
            return it.errors.length === 0;
        },
        get data() {
            return toJS(it.meta.value);
        },
        get validating() {
            return it._validating;
        }
    }); })
        .actions(function (it) { return ({
        addError: function (error) {
            it.errors.push(error);
        },
        addErrors: function (errors) {
            var _a;
            (_a = it.errors).push.apply(_a, __spread(errors));
        },
        clearErrors: function () {
            it.errors.length = 0;
        }
    }); })
        .actions(function (it) { return ({
        reset: function () {
            it.meta.setValue(it.meta.initial);
            it.clearErrors();
        },
        validate: function () {
            if (it.syncing /*|| it.validating*/) {
                return [];
            }
            it.clearErrors();
            it._validating = true;
            it.addErrors(it.tryValidate(it.meta.value));
            it._validating = false;
        }
    }); })
        .actions(function (it) { return ({
        // protected only method
        setValue: function (value) {
            it.meta.setValue(value);
        }
    }); })
        .actions(function (it) { return ({
        sync: function (value) {
            if (!it.syncing) {
                it.syncing = true;
                it.setValue(value);
                it.syncing = false;
                it.validate();
            }
        }
    }); });
    return Value;
}
//# sourceMappingURL=Value.js.map