var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import { isArray, keys } from "./common";
export function metafy(type, meta) {
    if (!meta) {
        return type;
    }
    if (type.type !== meta.type) {
        throw new Error("types not matching for type : " + type.title);
    }
    switch (type.type) {
        case "object": {
            var _a = type.properties, properties_1 = _a === void 0 ? {} : _a;
            var _b = meta, mproperties_1 = _b.properties, _ = _b.type, others = __rest(_b, ["properties", "type"]);
            return __assign({}, type, { meta: __assign({}, type.meta, others), properties: keys(properties_1).reduce(function (props, prop) {
                    props[prop] = metafy(properties_1[prop], mproperties_1[prop]);
                    return props;
                }, {}) });
        }
        case "array": {
            var items = type.items;
            var _c = meta, mitems_1 = _c.items, _ = _c.type, others = __rest(_c, ["items", "type"]);
            if (isArray(items) && mitems_1) {
                return __assign({}, type, { items: items.map(function (item, index) {
                        return metafy(item, mitems_1[index]);
                    }), meta: __assign({}, type.meta, others) });
            }
            else if (items && mitems_1) {
                return __assign({}, type, { items: metafy(items, mitems_1), meta: __assign({}, type.meta, others) });
            }
            else {
                return __assign({}, type, { meta: __assign({}, type.meta, others) });
            }
        }
        case "null":
        case "number":
        case "boolean":
        case "string": {
            var _ = meta.type, others = __rest(meta, ["type"]);
            return __assign({}, type, { meta: __assign({}, type.meta, others) });
        }
    }
}
//# sourceMappingURL=metafy.js.map