var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { isArray, isUndefined, keys } from "./common";
export function valuefy(type, value) {
    if (isUndefined(value)) {
        return type;
    }
    switch (type.type) {
        case "object": {
            var _a = type.properties, properties_1 = _a === void 0 ? {} : _a;
            return __assign({}, type, { properties: keys(properties_1).reduce(function (props, prop) {
                    props[prop] = valuefy(properties_1[prop], isUndefined(value) ? undefined : value[prop]);
                    return props;
                }, {}) });
        }
        case "array": {
            var items = type.items;
            if (isArray(items)) {
                return __assign({}, type, { items: items.map(function (item, index) {
                        return valuefy(item, isUndefined(value) ? undefined : value[index]);
                    }) });
            }
        }
        case "null":
        case "number":
        case "boolean":
        case "string":
            return __assign({}, type, { meta: __assign({}, type.meta, { value: value }) });
    }
}
//# sourceMappingURL=valuefy.js.map