"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var mobx_state_tree_1 = require("mobx-state-tree");
var mobx_1 = require("mobx");
var Common_1 = require("../Common");
var Type_1 = require("../Type");
var utils_1 = require("../utils");
var Value_1 = require("../Value");
var Meta_1 = require("../Meta");
Common_1.mappings.array = mobx_state_tree_1.types.late("Array", createArray);
var NArray;
exports.ArrayMeta = mobx_state_tree_1.types.compose("ArrayMeta", Meta_1.createMeta(mobx_state_tree_1.types.array(mobx_state_tree_1.types.frozen), [], "list", "layout", "checkboxes"), mobx_state_tree_1.types.model({}));
function createArray() {
    if (!NArray) {
        var Array_1 = mobx_state_tree_1.types
            .compose("Array", Value_1.createValue("array", mobx_state_tree_1.types.array(mobx_state_tree_1.types.frozen), [], exports.ArrayMeta, {
            component: "list"
        }), mobx_state_tree_1.types.model({
            additionalItems: mobx_state_tree_1.types.maybe(mobx_state_tree_1.types.boolean),
            elements: mobx_state_tree_1.types.optional(mobx_state_tree_1.types.array(mobx_state_tree_1.types.late(Type_1.createType)), []),
            items: mobx_state_tree_1.types.optional(mobx_state_tree_1.types.frozen, null),
            maxItems: mobx_state_tree_1.types.maybe(mobx_state_tree_1.types.number),
            minItems: mobx_state_tree_1.types.maybe(mobx_state_tree_1.types.number),
            uniqueItems: mobx_state_tree_1.types.maybe(mobx_state_tree_1.types.boolean)
        }))
            .views(function (it) { return ({
            get dynamic() {
                return !utils_1.isArray(it.items);
            }
        }); })
            .actions(function (it) { return ({
            updateIndexValue: function (index, value) {
                it.meta.value[index] = value;
                if (it.elements.length > index) {
                    // TODO: Need to fix for all types
                    it.elements[index].setValue(value);
                }
            },
            removeIndexValue: function (index) {
                it.meta.value.splice(index, 1);
            }
        }); })
            .actions(function (it) { return ({
            getConfig: function (value, index, element) {
                var Type = Type_1.createType();
                var type = Type.create(__assign({}, element, { meta: {
                        value: mobx_1.toJS(value)
                    } }));
                mobx_1.observe(type.meta, "value", function (changes) {
                    it.updateIndexValue(index, type.meta.value);
                });
                return type;
            }
        }); })
            .actions(function (it) { return ({
            updateElements: function (values) {
                var _a;
                if (values != null && it.items !== null) {
                    it.elements.length = 0;
                    if (!utils_1.isArray(it.items)) {
                        (_a = it.elements).push.apply(_a, __spread(values.map(function (value, index) {
                            return it.getConfig(value, index, it.items);
                        })));
                    }
                    else {
                        it.items.forEach(function (item, index) {
                            it.elements.push(it.getConfig(values.length > index ? values[index] : null, index, item));
                        });
                    }
                }
            },
            push: function () {
                if (it.dynamic) {
                    var meta = it.items.meta;
                    var value = meta ? meta.default : undefined;
                    var index = it.meta.value.length;
                    it.updateIndexValue(index, value);
                    it.elements.push(it.getConfig(value, index, it.items));
                    it.validate();
                }
            },
            remove: function (index) {
                if (it.dynamic) {
                    it.removeIndexValue(index);
                    var element = it.elements[index];
                    mobx_state_tree_1.detach(element);
                    // it.elements.splice(index, 1);
                    it.validate();
                }
            }
        }); })
            .actions(function (it) { return ({
            afterCreate: function () {
                if (it.minItems !== null && it.minItems < 0) {
                    throw new TypeError("minItems can not be negative");
                }
                if (it.maxItems !== null && it.maxItems < 0) {
                    throw new TypeError("maxItems can not be negative");
                }
                it.updateElements(mobx_1.toJS(it.meta.value));
            }
        }); })
            .actions(function (it) { return ({
            doValidate: function (value) {
                var e_1, _a;
                var errors = it.doValidateBase(value);
                if (value === null) {
                    return errors;
                }
                if (it.minItems !== null && value.length < it.minItems) {
                    errors.push("should NOT have less than " + it.minItems + " items");
                }
                if (it.maxItems !== null && value.length > it.maxItems) {
                    errors.push("should NOT have more than " + it.maxItems + " items");
                }
                if (it.uniqueItems !== null &&
                    it.uniqueItems &&
                    value.length !== utils_1.unique(value).length) {
                    errors.push("should NOT have duplicate items");
                }
                if (utils_1.isArray(it.items) &&
                    it.additionalItems !== null &&
                    it.additionalItems === false) {
                    if (value.length > it.items.length) {
                        errors.push("should NOT have additional items");
                    }
                }
                if (it.elements !== null) {
                    try {
                        for (var _b = __values(it.elements), _c = _b.next(); !_c.done; _c = _b.next()) {
                            var element = _c.value;
                            element.validate();
                        }
                    }
                    catch (e_1_1) { e_1 = { error: e_1_1 }; }
                    finally {
                        try {
                            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                        }
                        finally { if (e_1) throw e_1.error; }
                    }
                }
                return errors;
            },
            setValue: function (value) {
                it.meta.setValue(value);
                it.updateElements(mobx_1.toJS(value));
            }
        }); })
            .views(function (it) { return ({
            getFieldErrors: function () {
                return it.elements.reduce(function (errors, element, index) {
                    errors.items[index] = element
                        .getFieldErrors
                        ? element.getFieldErrors()
                        : mobx_1.toJS(element.errors);
                    return errors;
                }, { errors: mobx_1.toJS(it.errors), items: [] });
            },
            get data() {
                return it.elements.reduce(function (data, element, index) {
                    data[index] = element.data;
                    return data;
                }, __spread(mobx_1.toJS(it.meta.value || [])));
            },
            get valid() {
                return (it.errors.length === 0 &&
                    it.elements.every(function (element) { return element.valid; }));
            },
            get modified() {
                return it.elements.some(function (element) { return element.modified; });
            },
            get validating() {
                return (it._validating ||
                    it.elements.some(function (element) { return element.validating; }));
            }
        }); });
        NArray = Array_1;
    }
    return NArray;
}
exports.createArray = createArray;
//# sourceMappingURL=Array.js.map