import { IModelType } from "mobx-state-tree";
import { IValue, IValueAttrs, IValueConfig } from "../Value";
import { IMeta, IMetaAttrs, IMetaConfig } from "../Meta";
export declare type IBooleanComponent = "radios" | "checkbox" | "switch" | "select";
export interface IBooleanMetaAttrs extends IMetaAttrs<boolean, IBooleanComponent> {
}
export interface IBooleanMetaConfig extends IMetaConfig<boolean, IBooleanComponent>, IBooleanMetaAttrs {
}
export interface IBooleanMeta extends IMeta<boolean, IBooleanComponent>, IBooleanMetaAttrs {
}
export declare type IBooleanType = "boolean";
export interface IBooleanMetaProps extends IBooleanMetaConfig {
    readonly type: IBooleanType;
}
export interface IBooleanAttrs extends IValueAttrs<boolean> {
}
export interface IBooleanConfig extends IValueConfig<boolean, IBooleanType, IBooleanComponent, IBooleanMetaConfig>, Partial<IBooleanAttrs> {
}
export interface IBoolean extends IBooleanAttrs, IValue<boolean, IBooleanType, IBooleanComponent, IBooleanMetaConfig, IBooleanMeta> {
}
export declare const BooleanMeta: IModelType<Partial<IBooleanMetaConfig>, IBooleanMeta>;
export declare const Boolean: IModelType<Partial<IBooleanConfig>, IBoolean>;
export declare function createBoolean(): IModelType<Partial<IBooleanConfig>, IBoolean>;
