"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var mobx_state_tree_1 = require("mobx-state-tree");
var Common_1 = require("../Common");
var Value_1 = require("../Value");
var Meta_1 = require("../Meta");
exports.BooleanMeta = mobx_state_tree_1.types.compose("BooleanMeta", Meta_1.createMeta(mobx_state_tree_1.types.boolean, false, "radios", "checkbox", "switch", "select"), mobx_state_tree_1.types.model({}));
// tslint:disable-next-line:variable-name
exports.Boolean = mobx_state_tree_1.types
    .compose("Boolean", Value_1.createValue("boolean", mobx_state_tree_1.types.boolean, false, exports.BooleanMeta, { component: "switch" }), mobx_state_tree_1.types.model({}))
    .actions(function (it) { return ({
    afterCreate: function () {
        if (it.enum) {
            if (!(it.enum.length === 2)) {
                throw new TypeError("boolean enum should be two values. '" + it.enum + "' is invalid.");
            }
            if (it.enum[0] !== true && it.enum[0] !== false) {
                throw new TypeError("boolean enum should have either 'true' or 'false'");
            }
            if (it.enum[1] !== true && it.enum[1] !== false) {
                throw new TypeError("boolean enum should have either 'true' or 'false'");
            }
        }
        var component = it.meta.component;
        if ((component === "select" || component === "radios") &&
            (!it.enum || it.enum.length === 0)) {
            it.enum = [true, false];
        }
        if (it.enum &&
            it.enum.length > 0 &&
            (!it.meta.options || it.meta.options.length === 0)) {
            var options = it.enum.map(function (option) { return ({
                label: String(option),
                value: option
            }); });
            it.meta.setOptions(options);
        }
    }
}); });
Common_1.mappings.boolean = exports.Boolean;
function createBoolean() {
    return exports.Boolean;
}
exports.createBoolean = createBoolean;
//# sourceMappingURL=Boolean.js.map