import { IOption } from "../Common";
import { IModelType, ISimpleType } from "mobx-state-tree";
export interface IMetaAttrs<V, T> {
    readonly component?: T | null;
    readonly help?: string | null;
    readonly icon?: string | null;
    readonly iconAlign?: "start" | "end" | null;
    readonly error?: string | null;
    readonly row?: boolean | null;
    readonly sequence?: number | null;
    readonly initial?: V | null;
    readonly value?: V | null;
    readonly default?: V | null;
    readonly options?: Array<IOption<V>> | null;
}
export interface IMetaConfig<V, T> extends IMetaAttrs<V, T> {
    readonly name?: string | null;
    readonly disabled?: boolean | null;
    readonly visible?: boolean | null;
    readonly mandatory?: boolean | null;
}
export interface IMeta<V, T> extends IMetaAttrs<V, T> {
    readonly name: string;
    readonly disabled: boolean;
    readonly visible: boolean;
    readonly mandatory: boolean;
    setName(name: string): void;
    setMandatory(mandatory: boolean): void;
    setDisabled(disabled: boolean): void;
    setVisible(visible: boolean): void;
    setInitial(initial: V): void;
    setDefault(defaultV: V): void;
    setValue(value: V): void;
    setOptions(options: Array<IOption<V>>): void;
}
export declare function createMeta<V, T extends string, C extends IMetaConfig<V, T>, M extends IMeta<V, T> & C>(kind: ISimpleType<V>, defaultv: V, ...components: T[]): IModelType<Partial<C>, M>;
