"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var mobx_state_tree_1 = require("mobx-state-tree");
function createMeta(kind, defaultv) {
    var components = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        components[_i - 2] = arguments[_i];
    }
    var Meta = mobx_state_tree_1.types
        .model("Meta", {
        component: mobx_state_tree_1.types.maybe(mobx_state_tree_1.types.enumeration("component", components)),
        default: mobx_state_tree_1.types.optional(kind, defaultv),
        disabled: mobx_state_tree_1.types.optional(mobx_state_tree_1.types.boolean, false),
        error: mobx_state_tree_1.types.maybe(mobx_state_tree_1.types.string),
        help: mobx_state_tree_1.types.maybe(mobx_state_tree_1.types.string),
        icon: mobx_state_tree_1.types.maybe(mobx_state_tree_1.types.string),
        iconAlign: mobx_state_tree_1.types.optional(mobx_state_tree_1.types.enumeration("iconAlign", ["start", "end"]), "start"),
        initial: mobx_state_tree_1.types.optional(kind, defaultv),
        mandatory: mobx_state_tree_1.types.optional(mobx_state_tree_1.types.boolean, false),
        name: mobx_state_tree_1.types.optional(mobx_state_tree_1.types.string, ""),
        options: mobx_state_tree_1.types.maybe(mobx_state_tree_1.types.array(mobx_state_tree_1.types.model({ label: mobx_state_tree_1.types.string, value: kind }))),
        row: mobx_state_tree_1.types.maybe(mobx_state_tree_1.types.boolean),
        sequence: mobx_state_tree_1.types.maybe(mobx_state_tree_1.types.number),
        value: mobx_state_tree_1.types.optional(kind, defaultv),
        visible: mobx_state_tree_1.types.optional(mobx_state_tree_1.types.boolean, true)
    })
        .actions(function (it) { return ({
        afterCreate: function () {
            it.initial = it.value;
        }
    }); })
        .actions(function (it) { return ({
        setName: function (name) {
            it.name = name;
        },
        setMandatory: function (mandatory) {
            it.mandatory = mandatory;
        },
        setDisabled: function (disabled) {
            it.disabled = disabled;
        },
        setVisible: function (visible) {
            it.visible = visible;
        },
        setInitial: function (initial) {
            it.initial = initial;
        },
        setValue: function (value) {
            it.value = value;
        },
        setDefault: function (defaultV) {
            it.default = defaultV;
        },
        setOptions: function (options) {
            it.options = options;
        }
    }); });
    return Meta;
}
exports.createMeta = createMeta;
//# sourceMappingURL=Meta.js.map