"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Null_1 = require("./Null");
describe("Null testing", function () {
    var config = {
        meta: {
            component: "para",
            help: "null type test",
            value: null
        },
        title: "naguvan",
        type: "null"
    };
    test("check null default meta", function () {
        var type = Null_1.Null.create();
        expect(type.meta).not.toBeNull();
        expect(type.meta.component).toBe("para");
        expect(type.meta.sequence).toBeNull();
        expect(type.meta.help).toBeNull();
    });
    test("test null meta", function () {
        var type = Null_1.Null.create(config);
        expect(type.meta).not.toBeNull();
        expect(type.meta.component).toBe("para");
        expect(type.meta.help).toBe("null type test");
        expect(type.meta.sequence).toBeNull();
    });
    test("create null type", function () {
        var type = Null_1.Null.create(config);
        expect(type.type).toBe("null");
        expect(type.title).toBe("naguvan");
        expect(type.meta.value).toBe(null);
    });
    test("change null name type", function () {
        var type = Null_1.Null.create(config);
        type.meta.setName("skclusive");
        expect(type.meta.name).toBe("skclusive");
    });
});
//# sourceMappingURL=Null.test.js.map