import { IModelType } from "mobx-state-tree";
import { IValue, IValueAttrs, IValueConfig } from "../Value";
import { IMeta, IMetaAttrs, IMetaConfig } from "../Meta";
export declare type IStringComponent = "text" | "select" | "date" | "color" | "password" | "datetime" | "time" | "textarea";
export interface IStringMetaAttrs extends IMetaAttrs<string, IStringComponent> {
    readonly rows?: number | null;
    readonly rowsMax?: number | null;
}
export interface IStringMetaConfig extends IMetaConfig<string, IStringComponent>, IStringMetaAttrs {
}
export interface IStringMeta extends IMeta<string, IStringComponent>, IStringMetaAttrs {
}
export declare type IFormat = "date" | "date-time" | "uri" | "uri-reference" | "uri-template" | "url" | "email" | "hostname" | "ipv4" | "ipv6" | "regex" | "uuid" | "json-pointer" | "json-pointer-uri-fragment" | "relative-json-pointer" | "alpha" | "alphanumeric" | "identifier" | "hexadecimal" | "numeric" | "time" | "color" | "host-name" | "style" | "phone" | "ip-address" | "uppercase" | "lowercase" | "utc-millisec" | null;
export declare type IStringType = "string";
export interface IStringMetaProps extends IStringMetaConfig {
    readonly type: IStringType;
}
export interface IStringAttrs extends IValueAttrs<string> {
    readonly minLength?: number | null;
    readonly maxLength?: number | null;
    readonly pattern?: string | null;
    readonly format?: IFormat | null;
}
export interface IStringConfig extends IValueConfig<string, IStringType, IStringComponent, IStringMetaConfig>, Partial<IStringAttrs> {
}
export interface IString extends IStringAttrs, IValue<string, IStringType, IStringComponent, IStringMetaConfig, IStringMeta> {
}
export declare const StringMeta: IModelType<Partial<IStringMetaConfig>, IStringMeta>;
export declare const String: IModelType<Partial<IStringConfig>, IString>;
export declare function createString(): IModelType<Partial<IStringConfig>, IString>;
