"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var mobx_state_tree_1 = require("mobx-state-tree");
var utils_1 = require("../utils");
var Common_1 = require("../Common");
var matchers_1 = require("./matchers");
var Value_1 = require("../Value");
var Meta_1 = require("../Meta");
exports.StringMeta = mobx_state_tree_1.types.compose("StringMeta", Meta_1.createMeta(mobx_state_tree_1.types.string, "", "text", "select", "color", "date", "password", "datetime", "textarea", "time"), mobx_state_tree_1.types.model({
    rows: mobx_state_tree_1.types.maybe(mobx_state_tree_1.types.number),
    rowsMax: mobx_state_tree_1.types.maybe(mobx_state_tree_1.types.number)
}));
// tslint:disable-next-line:variable-name
exports.String = mobx_state_tree_1.types
    .compose("String", Value_1.createValue("string", mobx_state_tree_1.types.string, "", exports.StringMeta, {
    component: "text"
}), mobx_state_tree_1.types.model({
    format: mobx_state_tree_1.types.maybe(mobx_state_tree_1.types.union.apply(mobx_state_tree_1.types, __spread(Object.keys(matchers_1.matchers).map(function (format) { return mobx_state_tree_1.types.literal(format); })))),
    maxLength: mobx_state_tree_1.types.maybe(mobx_state_tree_1.types.number),
    minLength: mobx_state_tree_1.types.maybe(mobx_state_tree_1.types.number),
    pattern: mobx_state_tree_1.types.maybe(mobx_state_tree_1.types.string)
}))
    .actions(function (it) { return ({
    afterCreate: function () {
        if (it.pattern != null && !utils_1.regex(it.pattern)) {
            throw new TypeError("pattern '" + it.pattern + "' is invalid.");
        }
    }
}); })
    .actions(function (it) { return ({
    doValidate: function (value) {
        var errors = it.doValidateBase(value);
        if (it.minLength !== null && value.length < it.minLength) {
            errors.push("should NOT be shorter than " + it.minLength + " characters");
        }
        if (it.maxLength !== null && value.length > it.maxLength) {
            errors.push("should NOT be longer than " + it.maxLength + " characters");
        }
        if (it.pattern !== null && !value.match(utils_1.regex(it.pattern))) {
            errors.push("should match pattern " + it.pattern);
        }
        if (it.format != null && !matchers_1.matchers[it.format](value)) {
            errors.push("should match format " + it.format);
        }
        return errors;
    }
}); });
Common_1.mappings.string = exports.String;
function createString() {
    return exports.String;
}
exports.createString = createString;
//# sourceMappingURL=String.js.map