import { IComplexType as IMobxType } from "mobx-state-tree";
import { IArray, IArrayConfig, IArrayMetaProps } from "../Array";
import { IBoolean, IBooleanConfig, IBooleanMetaProps } from "../Boolean";
import { INull, INullConfig, INullMetaProps } from "../Null";
import { INumber, INumberConfig, INumberMetaProps } from "../Number";
import { IObject, IObjectConfig, IObjectMetaProps } from "../Object";
import { IString, IStringConfig, IStringMetaProps } from "../String";
export declare type ITypeMetaProps = IStringMetaProps | INumberMetaProps | IBooleanMetaProps | INullMetaProps | IObjectMetaProps | IArrayMetaProps;
export declare type ITypeConfig = IStringConfig | INumberConfig | IBooleanConfig | INullConfig | IObjectConfig | IArrayConfig;
export declare type IType = IString | INumber | IBoolean | INull | IObject | IArray;
export declare function createType(): IMobxType<Partial<ITypeConfig>, IType>;
import "../String";
import "../Number";
import "../Boolean";
import "../Null";
import "../Object";
import "../Array";
