import { IModelType } from "mobx-state-tree";
import { ISimpleType } from "mobx-state-tree";
import { IAnything } from "../Common";
import { IMeta, IMetaConfig } from "../Meta";
export interface IValueAttrs<V> {
    readonly title?: string | null;
    readonly enum?: V[] | null;
    readonly const?: V | null;
}
export interface IValueConfig<V, T, C, M extends IMetaConfig<V, C>> extends Partial<IValueAttrs<V>> {
    readonly type: T;
    readonly meta?: M | null;
}
export interface IValue<V, T, C, M extends IMetaConfig<V, C>, F extends M & IMeta<V, C>> extends IValueAttrs<V> {
    readonly type: T;
    readonly meta: F;
    readonly modified: boolean;
    readonly validating: boolean;
    readonly syncing: boolean;
    readonly data: V;
    readonly valid: boolean;
    readonly errors: string[];
    setValue(value: V): void;
    setTitle(title: string): void;
    reset(): void;
    validate(): void;
    addError(error: string): void;
    addErrors(errors: string[]): void;
    clearErrors(): void;
    sync(value: V): void;
    tryValue(value: IAnything): boolean;
    tryValidate(value: IAnything | undefined | null): string[];
    doValidate(value: V): string[];
    doValidateBase(value: V): string[];
}
export declare function createValue<V, T, C, M extends IMetaConfig<V, C>, F extends M & IMeta<V, C>>(type: T, kind: ISimpleType<V>, defaultv: V, meta: IModelType<Partial<M>, F>, defaultMeta: M): IModelType<Partial<IValueConfig<V, T, C, M>>, IValue<V, T, C, M, F>>;
